#ifndef MESSAGE_H
#define MESSAGE_H



#ifndef chrono
#include <chrono>
#endif

#ifndef thread
#include <thread>
#endif

#ifndef unordered_map
#include <unordered_map>
#endif

#ifndef string
#include <string>
#endif

#ifndef iostream
#include <iostream>
#endif

#include "SerialPort.h"



class message{

private:

    
    
    
    
public:
    
    unsigned char Message[64];
    
    unsigned char Reply[64];
    
    unsigned char MessData[60];
    
    std::string rType;
    
    std::string rSubType;
    
    int rValue;
    
    int SerialNum;
    
    std::unordered_map<std::string, int> Header;
     
    std::unordered_map<char, std::string> SubTypeRx;
    
    std::unordered_map<std::string, char> SubTypeTx;
    
    std::unordered_map<char, std::string> TypeRx;
    
    std::unordered_map<std::string, char> TypeTx;
    
    std::unordered_map<char, std::string> ErrorRx;
    
    std::unordered_map<std::string, char> ErrorTx;


    message();
    
    void createMessage(std::string Type, std::string SubType, int Value);
    
    /*void  createMessage(int Type, int SubType, int Value[64])*/  //Don't need here, not sending data
    
    bool waitForMessage(unsigned char ReplyBuffer[64], SerialPort readPort, double  waitTime);
    
    int sendMessage(unsigned char ReplyBuffer[64], SerialPort writePort, std::string Type, std::string SubType, int Value);
    
    void parseMessage(unsigned char messageArray[]);
    
};

#endif // MESSAGE_H
